import torch
import torch.nn.functional as F
import numpy as np
import matplotlib.pyplot as plt
from matplotlib.colors import hsv_to_rgb
plt.ion()

def show_c(fun, re_lim=[-3,3],im_lim=[-3,3],r_freq=16,θ_freq=16):
	re = torch.linspace(re_lim[0],re_lim[1],2**11)
	im = torch.linspace(im_lim[0],im_lim[1],2**11)
	#
	x,y = torch.meshgrid(re,im)
	z = x+1j*y
	r = z.abs()
	θ = z.angle()
	re = z.real
	im = z.imag
	#
	z = fun(z)
	#
	r = z.abs()
	θ = (z.angle()+np.pi)/2/np.pi
	# hsv = np.stack((θ,np.ones(r.shape),r),-1)
	# hsv = np.stack((θ,1.0*torch.ones(r.shape),torch.ones(r.shape)),-1)
	# hsv = np.stack((θ,torch.exp(-(0.01*r)**2),F.sigmoid(0.1*r)),-1)
	# hsv = np.stack((θ,F.sigmoid(0.5*r) - 0.9*F.sigmoid(-0.1*r),F.sigmoid(0.1*r)),-1)
	# hsv = np.stack((θ,F.sigmoid(r),F.sigmoid(0.5*r)),-1)
	hsv = np.stack((θ,1.-torch.exp(-1.0*r),1.-torch.exp(-0.5*r)),-1)
	# hsv = torch.stack((θ,r,r),-1)
	image = hsv_to_rgb(hsv)
	image[torch.sin(r_freq*r)>.98] = [.5,.5,.5]
	image[torch.sin(θ_freq*2*np.pi*θ).abs()>.99] = [.5,0,0]
	# plt.imshow(image,extent=(re_lim[0],re_lim[1],im_lim[0],im_lim[1]),origin="lower")
	plt.imshow(image.transpose(1,0,2),extent=(re_lim[0],re_lim[1],im_lim[0],im_lim[1]),origin="lower")
	plt.show()
	# return Image.fromarray((image.clip(0,1)*255).astype(np.uint8))
	# plt.contour(np.abs( np.exp(z*np.cos(θ)*np.cos(θ/2)) ), alpha=0.5)



# plt.clf()
# show_c(lambda z: z, re_lim=[-100,100],im_lim=[-100,100],r_freq=1,θ_freq=16)
# show_c(fun, ,r_freq=16,θ_freq=30)

